#include<stdio.h>

  /* Za cijeli broj n kazemo da je strogo rastuci, ako su dekadske
     znamenke broja |n| strogo rastuce, gledano od najnize prema
     najvisoj.
     Napisite program koji ucitava cijele brojeve n, sve dok se
     ne ucita broj koji nije strogo rastuci.
     Ukoliko je n strogo rastuci, program treba ispisati poruku
     "Broj je strogo rastuci", sumu svih znamenaka broja |n| i
     najvecu znamenku broja $|n|$. U protivnom, program treba ispisati
     poruku "Broj nije strogo rastuci".
     Smatramo da broj n = 0 ima jednu znamenku (jednaku 0).

     Primjer: Brojevi n = 851, n = -851 i n = 0 su strogo rastuci,
     a brojevi n = 25, n = -25 i n = 44 nisu strogo rastuci.
  */

int main(void) {

    int monoton = 1, n, pom_n, znam, preth_znam,
        suma_znam, max_znam;

        /* Petlja za obradu niza brojeva. */

    while (1) {  // Moze i  do { ... } while (monoton);

        printf("Upisite cijeli broj:\n");
        scanf("%d", &n);

            /* Apsolutna vrijednost |n|. */
        if (n < 0) n = -n;

            /* Pomocni n za provjeru monotonosti znamenki. */
        pom_n = n;

            /* Prva (najniza) znamenka. */
        preth_znam = pom_n % 10;
        pom_n /= 10;

            /* Petlja za provjeru trazene monotonosti za parove
               susjednih znamenki - prethodne i trenutne.
               Jednoznamenkasti n i n = 0 su monotoni (po def.).
               Petlja se tada NE izvrsava, a monoton ostaje na 1. */

        while (pom_n > 0) {
            znam = pom_n % 10;
            if (znam <= preth_znam) {  // Pogresan poredak.
                monoton = 0;
                break;
            }
            preth_znam = znam;  // Pomak trenutne u prethodnu.
            pom_n /= 10;
        }

            /* Nastavak posla, ovisno o tome je li broj n
               monoton ili ne. Dalje radimo s n, bez pomocnog. */

        if (monoton) {  // Broj n je monoton. Nadji ostalo sto treba.

            suma_znam = 0;
            max_znam = -1;  // Lazna inicijalizacija.

                /* Po dogovoru, n = 0 ima jednu znamenku jednaku 0.
                   Zato do-while, a NE while petlja! */
            do {
                znam = n % 10;
                suma_znam += znam;
                if (znam > max_znam) max_znam = znam;
                n /= 10;
            } while (n > 0);

/* Napomena: Znamo da je broj strogo rastuci.
     Onda je najveca znamenka = NAJVISA! Potrebne promjene su:
     Obrisati inicijalizaciju max_znam.
     U do-while petlji, if treba biti:
                if (n < 10) max_znam = znam;
*/

            printf("Broj je strogo rastuci\n");
            printf("Suma znamenaka je %d\n", suma_znam);
            printf("Najveca znamenka je %d\n", max_znam);
        }
        else {  // Broj n nije monoton. Poruka i prekid petlje.
            printf("Broj nije strogo rastuci");
            break;  // Kraj niza.
        }
    }

    return 0;
}
